#include "flprogModbusSlaveRTUoverTCP.h"

void ModbusSlaveRTUoverTCP::setTcpDevice(FLProgTcpDevice *device)
{
    tcpDevice = device;
}

void ModbusSlaveRTUoverTCP::begin()
{
    tcpDevice->beServer();
    tcpDevice->begin();
    bufferSize = 0;
    lastRec = 0;
}


void ModbusSlaveRTUoverTCP::begin(byte address)
{
    slaveAddres = address;
    begin();
}

void ModbusSlaveRTUoverTCP::pool()
{
    tcpDevice->connect();
    if (!tcpDevice->hasClient())
    {
        return;
    }
    ModbusSlaveRTU::pool();
}

bool ModbusSlaveRTUoverTCP::checkAvalibleBytes()
{
    byte avalibleBytes = tcpDevice->available();
    if (avalibleBytes == 0)
        return false;
    return true;
}

byte ModbusSlaveRTUoverTCP::rxBuffer()
{
    boolean bBuffOverflow = false;
    bufferSize = 0;
    while (tcpDevice->available())
    {
        buffer[bufferSize] = tcpDevice->read();
        bufferSize++;
        if (bufferSize >= 64)
            bBuffOverflow = true;
    }
    if (bBuffOverflow)
    {
        return -3;
    }
    return bufferSize;
}

void ModbusSlaveRTUoverTCP::sendTxBuffer()
{
    if (buffer[0] == 0)
    {
        bufferSize = 0;
        return;
    }
    byte i = 0;
    int crc = flprogModus::modbusCalcCRC(bufferSize, buffer);
    buffer[bufferSize] = crc >> 8;
    bufferSize++;
    buffer[bufferSize] = crc & 0x00ff;
    bufferSize++;
    tcpDevice->write(buffer, bufferSize);
    workStatus = MODBUS_READY;;
    bufferSize = 0;
}