#include "flprogModbusKaScadaCloud.h"

void ModbusKaScadaCloud::setKaScadaCloudIp(uint8_t newFirst_octet, uint8_t newSecond_octet, uint8_t newThird_octet, uint8_t newFourth_octet)
{
    if ((IPAddress(newFirst_octet, newSecond_octet, newThird_octet, newFourth_octet)) == cloudIp)
    {

        return;
    }
    cloudIp[0]=newFirst_octet;
    cloudIp[1]=newFirst_octet;
    cloudIp[2]=newFirst_octet;
    cloudIp[3]=newFirst_octet;
    tcpDevice->stop();
}

void ModbusKaScadaCloud::setKaScadaCloudPort(int newPort)
{
    if (port == newPort)

    {
        return;
    }
    port = newPort;
    tcpDevice->stop();
}

void ModbusKaScadaCloud::setKaScadaCloudDevceId(String id)
{
    if (deniceId.equals(id))

    {
        return;
    }
    deniceId = id;
    tcpDevice->stop();
}

void ModbusKaScadaCloud::begin()
{
    kaScadaCloudTimeOutStartTime = millis() + 5000;
    tcpDevice->beClient();
    tcpDevice->begin();
}


void ModbusKaScadaCloud::begin(byte address)
{
    slaveAddres = address;
    begin();
}

void ModbusKaScadaCloud::pool()
{
    if (flprog::isTimer(kaScadaCloudTimeOutStartTime, 5000))
    {
        if (tcpDevice->connected())
        {
            tcpDevice->print(deniceId);
            kaScadaCloudTimeOutStartTime = millis();
            return;
        }
        else
        {
            tcpDevice->connect(cloudIp, port);
            return;
        }
    }
    if (!tcpDevice->connected())
    {
        return;
    }

    if (tcpDevice->hasClient())
    {
        getRxBuffer();
    }
    else
    {
        return;
    }

    if (bufferSize == 0)
    {
        return;
    }
    executeSlaveReqest(data);
    kaScadaCloudTimeOutStartTime = millis();
}

void ModbusKaScadaCloud::sendTxBuffer()
{
    if (buffer[0] == 0)
    {
        return;
    }
    String stringBuffer = "";
    mbapBuffer[4] = highByte(bufferSize);
    mbapBuffer[5] = lowByte(bufferSize);
    tcpDevice->write(mbapBuffer, 6);
    tcpDevice->write(buffer, bufferSize);
    bufferSize = 0;
}

void ModbusKaScadaCloud::getRxBuffer()
{
    byte currentByte = 0;
    boolean buffOverflow = false;
    byte currentByteIndex = 0;
    bufferSize = 0;
    while (tcpDevice->available())
    {
        currentByte = tcpDevice->read();
        if (currentByteIndex < 6)

        {
            mbapBuffer[currentByteIndex] = currentByte;
        }
        else
        {
            buffer[bufferSize] = currentByte;
            bufferSize++;
            if (bufferSize >= 64)
                buffOverflow = true;
        }
        currentByteIndex++;
    }
}
