#include "flprogModbusSlaveTCP.h"

void ModbusSlaveTCP::setSlaveAddress(byte address)
{
    slaveAddres = address;
}

void ModbusSlaveTCP::setData(ModbusMainData *data)
{
    this->data = data;
}

void ModbusSlaveTCP::saveLong(long value, byte table, int startAddres)
{
    data->saveLong(value, table, startAddres);
}

void ModbusSlaveTCP::saveUnsignedLong(unsigned long value, byte table, int startAddres)
{
    data->saveUnsignedLong(value, table, startAddres);
}

void ModbusSlaveTCP::saveFloat(float value, byte table, int startAddres)
{
    data->saveFloat(value, table, startAddres);
}

void ModbusSlaveTCP::saveInteger(int value, byte table, int startAddres)
{
    data->saveInteger(value, table, startAddres);
}

void ModbusSlaveTCP::saveByte(byte value, byte table, int startAddres)
{
    data->saveByte(value, table, startAddres);
}

void ModbusSlaveTCP::saveBool(bool value, byte table, int startAddres)
{
    data->saveBool(value, table, startAddres);
}

byte ModbusSlaveTCP::readByte(byte table, int startAddres)
{
    return data->readByte(table, startAddres);
}

int ModbusSlaveTCP::readInteger(byte table, int startAddres)
{
    return data->readInteger(table, startAddres);
}

float ModbusSlaveTCP::readFloat(byte table, int startAddres)
{
    return data->readFloat(table, startAddres);
}

long ModbusSlaveTCP::readLong(byte table, int startAddres)
{
    return data->readLong(table, startAddres);
}

unsigned long ModbusSlaveTCP::readUnsignedLong(byte table, int startAddres)
{
    return data->readUnsignedLong(table, startAddres);
}

bool ModbusSlaveTCP::readBool(byte table, int startAddres)
{
    return data->readBool(table, startAddres);
}

byte ModbusSlaveTCP::getLastError()
{
    return lastError;
}

byte ModbusSlaveTCP::validateRequest()
{
    return validateSlaveReqest(data);
}

void ModbusSlaveTCP::begin()
{
    tcpDevice->beServer();
    tcpDevice->begin();
}

void ModbusSlaveTCP::begin(byte address)
{
    slaveAddres = address;
    begin();
}

void ModbusSlaveTCP::pool()
{
    tcpDevice->connect();
    if (tcpDevice->hasClient())
    {
        getRxBuffer();
    }
    else
    {
        return;
    }
    if (bufferSize == 0)
    {
        return;
    }
    executeSlaveReqest(data);
}

void ModbusSlaveTCP::getRxBuffer()
{
    boolean buffOverflow = false;
    byte currentByteIndex = 0;
    bufferSize = 0;
    while (tcpDevice->available())
    {
        if (currentByteIndex < 6)

        {
            mbapBuffer[currentByteIndex] = tcpDevice->read();
        }
        else
        {
            buffer[bufferSize] = tcpDevice->read();
            bufferSize++;
            if (bufferSize >= 64)
                buffOverflow = true;
        }
        currentByteIndex++;
    }
}

void ModbusSlaveTCP::sendTxBuffer()
{
    if (buffer[0] == 0)
    {
        return;
    }
    mbapBuffer[4] = highByte(bufferSize);
    mbapBuffer[5] = lowByte(bufferSize);
    tcpDevice->write(mbapBuffer, 6);
    tcpDevice->write(buffer, bufferSize);
    bufferSize = 0;
}