#pragma once
#include "Arduino.h"
#include "flprogModbusTCP.h"

class ModbusSlaveTCP : public ModbusTCP
{
public:
    void setSlaveAddress(byte address);
    void setData(ModbusMainData *data);
    void saveLong(long value, byte table, int startAddres);
    void saveUnsignedLong(unsigned long value, byte table, int startAddres);
    void saveFloat(float value, byte table, int startAddres);
    void saveInteger(int value, byte table, int startAddres);
    void saveByte(byte value, byte table, int startAddres);
    void saveBool(bool value, byte table, int startAddres);
    byte readByte(byte table, int startAddres);
    int readInteger(byte table, int startAddres);
    float readFloat(byte table, int startAddres);
    long readLong(byte table, int startAddres);
    unsigned long readUnsignedLong(byte table, int startAddres);
    bool readBool(byte table, int startAddres);
    byte getLastError();
    virtual void setLastError(byte error) { lastError = error; };
    virtual byte validateRequest();
    virtual void begin();
    virtual void begin(byte address);
    virtual void pool();
    void setTcpPort(int port) { tcpDevice->setPort(port); }

protected:
    byte slaveAddres = 1;
    ModbusMainData *data;
    byte lastError = 0;
    virtual void getRxBuffer();
    virtual void sendTxBuffer();
};